package java.beans;

import java.awt.Image;

class GenericBeanInfo extends SimpleBeanInfo {
   private BeanDescriptor beanDescriptor;
   private EventSetDescriptor[] events;
   private int defaultEvent;
   private PropertyDescriptor[] properties;
   private int defaultProperty;
   private MethodDescriptor[] methods;
   private BeanInfo targetBeanInfo;

   public GenericBeanInfo(BeanDescriptor var1, EventSetDescriptor[] var2, int var3, PropertyDescriptor[] var4, int var5, MethodDescriptor[] var6, BeanInfo var7) {
      this.beanDescriptor = var1;
      this.events = var2;
      this.defaultEvent = var3;
      this.properties = var4;
      this.defaultProperty = var5;
      this.methods = var6;
      this.targetBeanInfo = var7;
   }

   public PropertyDescriptor[] getPropertyDescriptors() {
      return this.properties;
   }

   public int getDefaultPropertyIndex() {
      return this.defaultProperty;
   }

   public EventSetDescriptor[] getEventSetDescriptors() {
      return this.events;
   }

   public int getDefaultEventIndex() {
      return this.defaultEvent;
   }

   public MethodDescriptor[] getMethodDescriptors() {
      return this.methods;
   }

   public BeanDescriptor getBeanDescriptor() {
      return this.beanDescriptor;
   }

   public Image getIcon(int var1) {
      return this.targetBeanInfo != null ? this.targetBeanInfo.getIcon(var1) : super.getIcon(var1);
   }
}
